// FMINSTR.C
// This program first initializes the FM Synthesizer chip, then
// configures voice 0 to piano. It then uninitializes the chip.

#include <stdlib.h>
#include "cvxfmsy.h"

VOID main( VOID )
{
   _FM_INIT_DATA   fmInitData;      // Initialization structure

   _BNK_INSTRUMENT   bnkInstrument  =    
   {
       0,  0,  1,  3,  3, 15,  5,  0,  1,  3,
      15,  0,  0,  0,  1,  0,  7,  0, 15,  7,
       0,  2,  4,  0,  0,  0,  1,  1,  0,  0
   }; // Piano

   // Set the port to port A( 388h )
   fmInitData.port = _FM_PORT_A;

   // Initialize the FM libraries
   if( !( fmInit( ( _FM_INIT_DATA * )&fmInitData ) ) )
   {
      // Set the instrument on voice 0
      if( fmSetInstrument((_BNK_INSTRUMENT far *)&bnkInstrument, 0 ))
         printf( "ERROR : fmSetInstrument() not successful.\n" );

      // Uninitialize the FM system
      if( fmUninit() )
         printf( "ERROR : fmUninit() not successful.\n" );
   }
   else
      printf( "ERROR : fmInit() not successful.\n" );
} 


